VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "c3Dsound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' the csound object this class is layered upon
Public BaseSound As cSound
' the 3d sound memory buffer (must be created from a secondary sound buffer)
Public Buffer As DirectSound3DBuffer8






' gets the secondary buffer where 3d sound is to be held
Function Load(Optional MinDistance = DS3D_DEFAULTMINDISTANCE, Optional MaxDistance = DS3D_DEFAULTMAXDISTANCE, Optional ConeOutsideVolume As Long = DS3D_DEFAULTCONEOUTSIDEVOLUME) As Boolean
On Error GoTo LoadFailed
    Set Buffer = BaseSound.Buffer.GetDirectSound3DBuffer
    If Buffer Is Nothing Then Exit Function
    Buffer.SetMinDistance MinDistance, DS3D_DEFERRED
    Buffer.SetMaxDistance MaxDistance, DS3D_DEFERRED
    Buffer.SetConeAngles DS3D_MINCONEANGLE, DS3D_MAXCONEANGLE, DS3D_DEFERRED
    Buffer.SetConeOutsideVolume ConeOutsideVolume, DS3D_DEFERRED
    Listener.Update
    Load = Not Err.Number
    Exit Function
LoadFailed:
End Function



' sets the position of the sound (relative to the listener)
Sub SetPosition(newPosition As D3DVECTOR, Optional applyFlags As CONST_DS3DAPPLYFLAGS = DS3D_IMMEDIATE)
On Error Resume Next
    Buffer.SetPosition newPosition.x, newPosition.y, newPosition.z, applyFlags
End Sub



' gets/lets the position of the sound (relative to the listener) immediately
Property Get Position() As D3DVECTOR
On Error Resume Next
    Buffer.GetPosition Position
End Property
Property Let Position(pos As D3DVECTOR)
On Error Resume Next
    Buffer.SetPosition pos.x, pos.y, pos.z, DS3D_IMMEDIATE
End Property



' sets the velocity of the sound
Sub SetVelocity(newVelocity As D3DVECTOR, Optional applyFlags As CONST_DS3DAPPLYFLAGS = DS3D_IMMEDIATE)
On Error Resume Next
    Buffer.SetVelocity newVelocity.x, newVelocity.y, newVelocity.z, applyFlags
End Sub



' gets/lets the velocity of the sound (relative to the listener) immediately
Property Get Velocity() As D3DVECTOR
On Error Resume Next
    Buffer.GetPosition Position
End Property
Property Let Velocity(v As D3DVECTOR)
On Error Resume Next
    Buffer.SetPosition v.x, v.y, v.z, DS3D_IMMEDIATE
End Property



' get/let min/max distance immediately
Property Get MinDistance() As Single
On Error Resume Next
    MinDistance = Buffer.GetMinDistance
End Property
Property Let MinDistance(d As Single)
On Error Resume Next
    Buffer.SetMinDistance d, DS3D_IMMEDIATE
End Property

Property Get MaxDistance() As Single
On Error Resume Next
    MaxDistance = Buffer.GetMaxDistance
End Property
Property Let MaxDistance(d As Single)
On Error Resume Next
    Buffer.SetMaxDistance d, DS3D_IMMEDIATE
End Property



' get/let cone outside volume
Property Get ConeOutsideVolume() As Single
On Error Resume Next
    ConeOutsideVolume = Buffer.GetConeOutsideVolume
End Property
Property Let ConeOutsideVolume(vol As Single)
On Error Resume Next
    Buffer.SetConeOutsideVolume vol, DS3D_IMMEDIATE
End Property



' plays the loaded wave file in current 3d position and velocity
Sub Play(Optional Looping As Boolean = False)
On Error Resume Next
    BaseSound.Play Looping
End Sub



' stops playing the sound
Sub StopPlay()
On Error Resume Next
    BaseSound.StopPlay
End Sub



' clean up any mess this class has made
Private Sub Class_Terminate()
On Error Resume Next
    Set Buffer = Nothing
End Sub
