VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cKeyboard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' the input device, in this class, a keyboard
Public DIdevice As DirectInputDevice8
' the key states
Private State As DIKEYBOARDSTATE






' aquires a keyboard device
Function Init(hWnd As Long, Optional ForegroundOnly As Boolean = True) As Boolean
On Error GoTo InitFailed
    Set DIdevice = DI.CreateDevice("GUID_SysKeyboard")
    If DIdevice Is Nothing Then Exit Function
    DIdevice.SetCommonDataFormat DIFORMAT_KEYBOARD
    If ForegroundOnly Then
        DIdevice.SetCooperativeLevel hWnd, DISCL_NONEXCLUSIVE Or DISCL_FOREGROUND
    Else
        DIdevice.SetCooperativeLevel hWnd, DISCL_NONEXCLUSIVE Or DISCL_BACKGROUND
    End If
    DIdevice.Acquire
    Refresh
    Init = Not Err.Number
    Exit Function
InitFailed:
End Function



' updates the information in the state buffer
Sub Refresh()
On Error Resume Next
    DIdevice.GetDeviceStateKeyboard State
End Sub



' returns whether a key is down
Property Get KeyIsDown(KeyCode As CONST_DIKEYFLAGS) As Boolean
On Error Resume Next
    KeyIsDown = State.Key(KeyCode)
End Property



' unaquires the keyboard device
Private Sub Class_Terminate()
On Error Resume Next
    DIdevice.Unacquire
End Sub
