VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMaterial"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' holds the Mtrl data in a format that direct3d understands
Dim Mtrl As D3DMATERIAL8

' a user friendly name for the Mtrl
Public Tag As String






' set some defaults
Private Sub Class_Initialize()
On Error Resume Next
    SetAmbient 1, 1, 1, 1
    SetDiffuse 1, 1, 1, 1
    SetEmissive 0, 0, 0, 0
    SetSpecular 1, 1, 1, 1
    SetPower 10
End Sub



' get/set Mtrl
Property Get Material() As D3DMATERIAL8
On Error Resume Next
    Material = Mtrl
End Property
Property Let Material(newMaterial As D3DMATERIAL8)
On Error Resume Next
    Mtrl = newMaterial
End Property



' sets the material as the current one for the rendering device
Sub SetAsCurrent()
On Error Resume Next
    ' don't waste time setting as current if it's already done
    If lastMaterial Is Me Then Exit Sub
    ' commit to the device
    D3Ddevice.SetMaterial Mtrl
    ' cache this material as last material used
    Set lastMaterial = Me
End Sub



' sets the ambient color
Sub SetAmbient(a As Single, r As Single, g As Single, b As Single)
On Error Resume Next
    With Mtrl.Ambient
        .a = a
        .r = r
        .g = g
        .b = b
    End With
End Sub



' sets the diffuse color
Sub SetDiffuse(a As Single, r As Single, g As Single, b As Single)
On Error Resume Next
    With Mtrl.Diffuse
        .a = a
        .r = r
        .g = g
        .b = b
    End With
End Sub



' sets the emissive color
Sub SetEmissive(a As Single, r As Single, g As Single, b As Single)
On Error Resume Next
    With Mtrl.emissive
        .a = a
        .r = r
        .g = g
        .b = b
    End With
End Sub



' sets the specular color
Sub SetSpecular(a As Single, r As Single, g As Single, b As Single)
On Error Resume Next
    With Mtrl.Specular
        .a = a
        .r = r
        .g = g
        .b = b
    End With
End Sub



' sets the power
Sub SetPower(Power As Single)
On Error Resume Next
    Mtrl.Power = Power
End Sub

