VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' the object which represents the memory for the wave file
Public Buffer As DirectSoundSecondaryBuffer8

' a user friendly name for the sound, often the name
' of the wave file it was loaded from
Public Tag As String

' describes a directsound buffer
Private BufferDesc As DSBUFFERDESC






' set buffer description
Private Sub Class_Initialize()
On Error Resume Next
End Sub



' loads a wave file, this should be short so that it doesn't
' take too much memory
Function LoadFromFile(Optional Filename As String = "", Optional Algo3D = GUID_DS3DALG_NO_VIRTUALIZATION) As Boolean
On Error GoTo LoadFailed
    BufferDesc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_CTRLVOLUME ' allow 3d sounds, mutes them at max distance
    BufferDesc.guid3DAlgorithm = Algo3D
    If Filename = "" Then Filename = SoundPath & Tag
    Set Buffer = DS.CreateSoundBufferFromFile(Filename, BufferDesc)
    If Buffer Is Nothing Then Exit Function
    LoadFromFile = Not Err.Number
    Exit Function
LoadFailed:
End Function



' get/set volume
Property Get Volume() As Long
On Error Resume Next
    Volume = Buffer.GetVolume()
End Property
Property Let Volume(newVolume As Long)
On Error Resume Next
    Buffer.SetVolume newVolume
End Property



' plays the loaded wave file
Sub Play(Optional Looping As Boolean = False)
On Error Resume Next
    Buffer.SetCurrentPosition 0
    If Looping Then
        Buffer.Play DSBPLAY_LOOPING
    Else
        Buffer.Play DSBPLAY_DEFAULT
    End If
End Sub



' stops a playing wave file
Sub StopPlay()
On Error Resume Next
    Buffer.Stop
End Sub




Private Sub Class_Terminate()
On Error Resume Next
    Set Buffer = Nothing
End Sub
