VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTexture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' the memory for the texture surface
Public Texture As Direct3DTexture8

' the transparent color the texture uses
Public TransparentColor As Long

' a user friendly name for the texture, also can represent the filename
' the texture was loaded from
Public Tag As String






' default the transparent color to -1 (no transparency)
Private Sub Class_Initialize()
On Error Resume Next
    TransparentColor = -1
End Sub




' loads a texture from a bitmap or jpeg file
Function LoadFromFile(Optional Filename As String = "") As Boolean
'Dim hexColor As String
On Error GoTo LoadFailed
    If Filename = "" Then Filename = TexturePath & Tag
    Select Case UCase(Right(Filename, 3))
        Case "BMP" ' bitmap files are valid
        Case "JPG" ' jpgs can be turned to bitmaps easily
            Dim tmpPic As IPictureDisp
            Set tmpPic = LoadPicture(Filename)
            Filename = Left(Filename, Len(Filename) - 3) & "bmp"
            SavePicture tmpPic, Filename
        Case Else
            Exit Function
    End Select
    If TransparentColor < 0 Then
        Set Texture = D3DX.CreateTextureFromFile(D3Ddevice, Filename)
    Else
        'hexColor = Hex(TransparentColor)
        'hexColor = "&HFF" & Right(hexColor, Len(hexColor - 4))
        Set Texture = D3DX.CreateTextureFromFileEx(D3Ddevice, Filename, 0, 0, 0, 0, D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, &HFF000000, ByVal 0, ByVal 0)
    End If
    If Texture Is Nothing Then Exit Function
    LoadFromFile = True
    Exit Function
LoadFailed:
End Function



' set the texture as the current one for the rendering device
Sub SetAsCurrent()
On Error Resume Next
    ' don't waste time setting texture when its already done
    If lastTexture Is Me Then Exit Sub
    ' enable/disable transparency
    If TransparentColor < 0 Then
        D3Ddevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    Else
        D3Ddevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    End If
    ' commit texture to the device
    D3Ddevice.SetTexture 0, Texture
    ' cache this as last used texture
    Set lastTexture = Me
End Sub



' clean up the mess this object has made
Private Sub Class_Terminate()
On Error Resume Next
    Set Texture = Nothing
End Sub

