VERSION 5.00
Begin VB.Form frmDemo 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Engine X Demo"
   ClientHeight    =   5520
   ClientLeft      =   36
   ClientTop       =   312
   ClientWidth     =   7680
   Icon            =   "frmDemo.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   460
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   StartUpPosition =   2  'CenterScreen
   Begin VB.OptionButton optVHighRes 
      Caption         =   "V. High (1600 x 1200)"
      Height          =   492
      Left            =   120
      TabIndex        =   12
      Top             =   4920
      Width           =   1692
   End
   Begin VB.Frame fDemo 
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   612
      Left            =   120
      TabIndex        =   9
      Top             =   2760
      Width           =   1692
      Begin VB.OptionButton optMars 
         Caption         =   "Mars"
         Height          =   252
         Left            =   0
         TabIndex        =   11
         Top             =   0
         Width           =   1452
      End
      Begin VB.OptionButton optVillage 
         Caption         =   "Village"
         Height          =   372
         Left            =   0
         TabIndex        =   10
         Top             =   240
         Width           =   1452
      End
   End
   Begin VB.OptionButton optMedRes 
      Caption         =   "Medium (800 x 600)"
      Height          =   252
      Left            =   120
      TabIndex        =   8
      Top             =   4440
      Width           =   1692
   End
   Begin VB.OptionButton optHighRes 
      Caption         =   "High (1024 x 768)"
      Height          =   252
      Left            =   120
      TabIndex        =   7
      Top             =   4680
      Width           =   1692
   End
   Begin VB.OptionButton optLowRes 
      Caption         =   "Low (640 x 480)"
      Height          =   252
      Left            =   120
      TabIndex        =   6
      Top             =   4200
      Width           =   1692
   End
   Begin VB.OptionButton optVLowRes 
      Caption         =   "V. Low (320 x 240)"
      Height          =   252
      Left            =   120
      TabIndex        =   5
      Top             =   3960
      Width           =   1692
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   492
      Left            =   6000
      TabIndex        =   3
      Top             =   4920
      Width           =   1452
   End
   Begin VB.CommandButton cmdDemo 
      Caption         =   "Start Demo!"
      Height          =   492
      Left            =   6000
      TabIndex        =   2
      Top             =   2520
      Width           =   1452
   End
   Begin VB.TextBox txtReadMe 
      Height          =   2292
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "frmDemo.frx":0442
      Top             =   120
      Width           =   7452
   End
   Begin VB.Label lblRes 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Select Resolution"
      Height          =   372
      Left            =   120
      TabIndex        =   4
      Top             =   3600
      Width           =   1692
   End
   Begin VB.Label lblDemo 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Select A Demo"
      Height          =   372
      Left            =   120
      TabIndex        =   0
      Top             =   2520
      Width           =   1692
   End
   Begin VB.Image imgPreview 
      BorderStyle     =   1  'Fixed Single
      Height          =   2880
      Left            =   1920
      Stretch         =   -1  'True
      Top             =   2520
      Width           =   3840
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' the demo ends when this is true
Private EndNow As Boolean

' pointer to the camera used
Dim cam1stPerson As cCamera




' set default options, disable unavailable resolutions, load text file
Private Sub Form_Load()
Dim BestDevice As ENGINEX_DEVICE
Dim testMode As D3DDISPLAYMODE
On Error Resume Next
    ' find the best rendering device
    modEnumeration.FindBestDevice BestDevice
    ' enable/disable resolutions depending on whether they are available
    With testMode
        .Format = BestDevice.DisplayMode.Format
        .Width = 320: .Height = 240
        optVLowRes.Enabled = IsDisplayModeOK(testMode)
        .Width = 640: .Height = 480
        optLowRes.Enabled = IsDisplayModeOK(testMode)
        .Width = 800: .Height = 600
        optMedRes.Enabled = IsDisplayModeOK(testMode)
        .Width = 1024: .Height = 768
        optHighRes.Enabled = IsDisplayModeOK(testMode)
        .Width = 1600: .Height = 1200
        optVHighRes.Enabled = IsDisplayModeOK(testMode)
        If optVHighRes.Enabled Then optVHighRes = True
        If optHighRes.Enabled Then optHighRes = True
        If optMedRes.Enabled Then optMedRes = True
        If optLowRes.Enabled Then optLowRes = True
        If optVLowRes.Enabled Then optVLowRes = True
    End With
    ' load text
    Open App.Path & "\readme.txt" For Input As #1
    txtReadMe = Input(LOF(1), 1)
    Close #1
    ' choose default demo
    optMars_Click
End Sub



Private Sub cmdDemo_Click()
    LoadDemo
    If optMars Then MarsDemo Else VillageDemo
    UnloadDemo
End Sub



' exit the demo is escape is pressed
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyEscape Then EndNow = True
End Sub



' all directx loading and initialization is done here
Public Sub LoadDemo()
Dim BestDevice As ENGINEX_DEVICE
Dim w As Integer, h As Integer
On Error Resume Next
    ' make every control on the form disappear
    txtReadMe.Visible = False
    lblDemo.Visible = False
    lblRes.Visible = False
    imgPreview.Visible = False
    cmdDemo.Visible = False
    cmdExit.Visible = False
    optVLowRes.Visible = False
    optLowRes.Visible = False
    optMedRes.Visible = False
    optHighRes.Visible = False
    optVHighRes.Visible = False
    optMars.Visible = False
    optVillage.Visible = False
    fDemo.Visible = False
    Me.BorderStyle = 0
    Me.BackColor = vbBlack
    ' select the best rendering device
    modEnumeration.FindBestDevice BestDevice
    ' set screen resolution
    With BestDevice
        If optVLowRes Then: w = 320: h = 240
        If optLowRes Then: w = 640: h = 480
        If optMedRes Then: w = 800: h = 600
        If optHighRes Then: w = 1024: h = 768
        If optVHighRes Then: w = 1600: h = 1200
        If w = 0 Then Exit Sub
        .DisplayMode.Width = w
        .DisplayMode.Height = h
        If .Hardware Then
            MsgBox "engineX has detected that hardware acceleration is available, this demo should run nice and fast!", vbInformation, "Hardware Detected!"
        Else
            MsgBox "engineX has not detected hardware acceleration, so this demo may run slowly!", vbInformation, "No Hardware Acceleration!"
        End If
    End With
    ' load graphics engine
    If modGraphics.Init(hWnd, BestDevice) = False Then
        Open App.Path & "\data\error_logs\engineX_graphics_error_log.txt" For Random As #1
        Write #1, modGraphics.InitReport
        Close #1
    End If
    ' load audio engine
    modAudio.Init hWnd, DSSCL_PRIORITY
    ' initialize listener (for 3D sound)
    Listener.Init
    ' initialize input engine
    modInput.Init
    ' initialize keyboard and mouse devices
    Keyboard.Init hWnd, False
    Mouse.Init hWnd, False
    ' set resource file paths
    EXFfilePath = App.Path & "\data\exf_files\"
    XfilePath = App.Path & "\data\x_files\"
    TexturePath = App.Path & "\data\textures\"
    SoundPath = App.Path & "\data\sounds\"
End Sub



Public Sub VillageDemo()
On Error Resume Next
' variables to calculate time
Dim timeThis As Long
Dim timeLast As Long
Dim timeElapsed As Single
Dim strError As String
' this is filled with objects that the camera have collided with
Dim Collision() As CollisionDescription
Dim l As Long
Dim vec As D3DVECTOR
Dim angle As Single
' these are pointers to various objects that are loaded from the mars.exf file
Dim lgtMoon As cLight
Dim frameMoon As cFrame
Dim frameCar As cFrame
    ' load a scene of an alien planet from a .exf file
    If modEXFfile.LoadEXFfile("village.exf") <> EXF_OK Then
        Open App.Path & "\data\error_logs\engineX_exf_file_error_log.txt" For Random As #1
        Write #1, modEXFfile.ErrorLog
        Close #1
    End If
    ' get pointers to objects loaded from .exf file
    Set cam1stPerson = Camera(1)
    Set lgtMoon = Light(1)
    Set frameMoon = WorldFrame.ChildFrame(2)
    Set frameCar = WorldFrame.ChildFrame(6)
    timeLast = timeGetTime()
    Do
        DoEvents ' process windows messages
        timeThis = timeGetTime ' get current time in milliseconds
        timeElapsed = (timeThis - timeLast) / 1000 ' convert to seconds
        ' get more data from the mouse and keyboard
        Keyboard.Refresh
        Mouse.Refresh
        ' animate all objects in the engine
        modGeometry.RefreshAllLocations timeElapsed
        ' move the moonlight
        vec = frameMoon.Location(1).Orientation
        angle = vec.y
        vec.x = Sin(angle) * 300
        vec.y = 100
        vec.z = Cos(angle) * 300
        lgtMoon.SetPosition vec
        lgtMoon.Load
        lgtMoon.Enabled = True
        ' if the car drives off to far, turn it around
        With frameCar.Location(1)
            vec = .Origin
            If Abs(vec.z) > 200 Then
                vec.x = -vec.x
                .Origin = vec
                vec = .Orientation
                vec.y = -vec.y
                .Orientation = vec
                vec = .Velocity
                vec.z = -vec.z
                .Velocity = vec
                frameCar.Location(1).Refresh 0.1
            End If
        End With
        ' move the camera based on input
        With cam1stPerson
            ' if escape is pressed then exit demo
            If Keyboard.KeyIsDown(DIK_ESCAPE) Then EndNow = True
            ' if the left and right keys are pressed, rotate the camera
            If Keyboard.KeyIsDown(DIK_LEFTARROW) Then .Rotate Vector3(0, 0.08, 0)
            If Keyboard.KeyIsDown(DIK_RIGHTARROW) Then .Rotate Vector3(0, -0.08, 0)
            ' if the up arrow key is pressed, move the camera foward
            If Keyboard.KeyIsDown(DIK_UPARROW) Then
                For l = 1 To 10 ' move in small increments
                ' test for collisions between camera and other objects
                If Not modCollision.CollisionTestAllLocationsWithPoint(.Origin, .GetFowardVector(20, timeElapsed)) Then
                    .MoveFoward 2, timeElapsed ' nothing in the way, so move
                End If
                Next
            End If
            If Keyboard.KeyIsDown(DIK_DOWNARROW) Then
                For l = 1 To 10 ' move in small increments
                ' test for collisions between camera and other objects
                If Not modCollision.CollisionTestAllLocationsWithPoint(.Origin, .GetFowardVector(-20, timeElapsed)) Then
                    .MoveFoward -2, timeElapsed ' nothing in the way, so move
                End If
                Next
            End If
            ' rotate the camera based on mouse movement
            .Rotate Vector3(Mouse.z / 100, Mouse.x / -100, Mouse.y / -300)
            ' ensure the camera stays on the ground
            vec = .Origin
            vec.y = 6
            .Origin = vec
            ' update the camera
            .SetAsCurrent
        End With
        ' render the screen
        Form_Paint
        ' cache time
        timeLast = timeThis
    Loop Until EndNow ' carry on looping until endnow is true
End Sub



Public Sub MarsDemo()
On Error Resume Next
' variables to calculate time
Dim timeThis As Long
Dim timeLast As Long
Dim timeElapsed As Single
' this is filled with objects that the camera have collided with
Dim Collision() As CollisionDescription
Dim l As Long
Dim vecUFO As D3DVECTOR
Dim vecCam As D3DVECTOR
' angle of ufo from origin
Static angleUFO As Single
' these are pointers to various objects that are loaded from the mars.exf file
Dim frameUFO As cFrame
Dim lgtUFO As cLight
Dim frameSpace As cFrame
Dim sndUFO As c3Dsound
    ' load a scene of an alien planet from a .exf file
    If modEXFfile.LoadEXFfile("mars.exf") <> EXF_OK Then
        Open App.Path & "\data\error_logs\engineX_exf_file_error_log.txt" For Random As #1
        Write #1, modEXFfile.ErrorLog
        Close #1
    End If
    ' get pointers to objects loaded from .exf file
    Set cam1stPerson = Camera(1)
    Set frameUFO = WorldFrame.ChildFrame(3)
    Set frameSpace = WorldFrame.ChildFrame(1)
    Set sndUFO = Sound(2)
    Set lgtUFO = Light(2)
    timeLast = timeGetTime()
    Do
        DoEvents ' process windows messages
        timeThis = timeGetTime ' get current time in milliseconds
        timeElapsed = (timeThis - timeLast) / 1000 ' convert to seconds
        ' get more data from the mouse and keyboard
        Keyboard.Refresh
        Mouse.Refresh
        ' animate all objects in the engine
        modGeometry.RefreshAllLocations timeElapsed
        ' change the angle of the ufo
        angleUFO = angleUFO + timeElapsed
        ' calculate the new ufo position
        vecUFO.x = Sin(angleUFO) * 150
        vecUFO.y = Sin(angleUFO * 2) * 10 + 30
        vecUFO.z = Cos(angleUFO) * 150
        If vecUFO.y < 20.1 Then ' if the ufo is flying low, play a strange sound
            Listener.Update ' update the location of the listener
            sndUFO.Play ' play the sound
        End If
        ' move ufo and it's light and sound
        frameUFO.Location(1).Origin = vecUFO
        lgtUFO.SetPosition vecUFO
        lgtUFO.Load
        sndUFO.SetPosition vecUFO, DS3D_DEFERRED
        ' loop the ufo variable around in a circle
        If angleUFO > PI * 2 Then angleUFO = angleUFO = PI * 2
        ' move the camera based on input
        With cam1stPerson
            ' if escape is pressed then exit demo
            If Keyboard.KeyIsDown(DIK_ESCAPE) Then EndNow = True
            ' if the left and right keys are pressed, rotate the camera
            If Keyboard.KeyIsDown(DIK_LEFTARROW) Then .Rotate Vector3(0, 0.08, 0)
            If Keyboard.KeyIsDown(DIK_RIGHTARROW) Then .Rotate Vector3(0, -0.08, 0)
            ' if the up arrow key is pressed, move the camera foward
            If Keyboard.KeyIsDown(DIK_UPARROW) Then
                For l = 1 To 10 ' move in small increments
                ' test for collisions between camera and other objects
                If Not modCollision.CollisionTestAllLocationsWithPoint(.Origin, .GetFowardVector(20, timeElapsed)) Then
                    .MoveFoward 2, timeElapsed ' nothing in the way, so move
                End If
                Next
            End If
            If Keyboard.KeyIsDown(DIK_DOWNARROW) Then
                For l = 1 To 10 ' move in small increments
                ' test for collisions between camera and other objects
                If Not modCollision.CollisionTestAllLocationsWithPoint(.Origin, .GetFowardVector(-20, timeElapsed)) Then
                    .MoveFoward -2, timeElapsed ' nothing in the way, so move
                End If
                Next
            End If
            ' rotate the camera based on mouse movement
            .Rotate Vector3(Mouse.z / 100, Mouse.x / -100, Mouse.y / -300)
            ' move the background with the camera
            frameSpace.Location(1).Origin = .Origin
            ' ensure the camera stays on the ground
            vecCam = .Origin
            vecCam.y = 1
            .Origin = vecCam
            ' update the camera
            .SetAsCurrent
        End With
        ' render the screen
        Form_Paint
        ' cache time
        timeLast = timeThis
    Loop Until EndNow ' carry on looping until endnow is true
End Sub



Private Sub Form_Paint()
On Error Resume Next
    ' clear background
    modGraphics.Clear
    ' render scene
    modGraphics.Render
    ' flip onto screen
    modGraphics.Present
    ' print frame rate to debug screen
    'Debug.Print Int(modGraphics.FPS)
End Sub



Public Sub UnloadDemo()
On Error Resume Next
    ' clean up input objects
    modInput.CleanUp
    ' clean up audio objects
    modAudio.CleanUp
    ' clean up graphics objects
    modGraphics.CleanUp
    ' unload form
    Unload Me
End Sub



Private Sub cmdExit_Click()
Unload Me
End Sub


Private Sub Form_Unload(Cancel As Integer)
    ' well brutally and definately end
    End
End Sub

Private Sub optMars_Click()
On Error Resume Next
    optMars = True
    imgPreview = LoadPicture(App.Path & "\data\graphics\mars.jpg")
End Sub

Private Sub optVillage_Click()
On Error Resume Next
    imgPreview = LoadPicture(App.Path & "\data\graphics\village.jpg")
End Sub
