Attribute VB_Name = "modAudio"

Option Explicit

' the global directsound object
Public DS As DirectSound8
' for enumerating sound devices
Public DSenum As DirectSoundEnum8

' an array of sound objects
Public Sound() As Object

' the listener to the soudn
Public Listener As New cListener

' the resource paths
Public SoundPath As String
Public MusicPath As String






' initialize audio
Public Function Init(hWnd As Long, Optional CooperativeLevel As CONST_DSSCLFLAGS = DSSCL_NORMAL) As Boolean
On Error GoTo InitFailed
    ' initialize arrays and paths
    ReDim Sound(0)
    SoundPath = App.Path & "\"
    ' get a pointer to directsound
    Set DS = DX.DirectSoundCreate(vbNullString)
    If DS Is Nothing Then Exit Function
    DS.SetCooperativeLevel hWnd, CooperativeLevel
    Init = Not Err.Number
    Exit Function
InitFailed:
End Function



' creates a basic 2d sound
Function AddSound(Tag As String, Optional Algo3D = GUID_DS3DALG_NO_VIRTUALIZATION) As Boolean
On Error GoTo AddFailed
    ReDim Preserve Sound(0 To UBound(Sound) + 1)
    Set Sound(UBound(Sound)) = New cSound
    With Sound(UBound(Sound))
        .Tag = Tag
        AddSound = .LoadFromFile
    End With
    Exit Function
AddFailed:
End Function



' converts a loaded 2d sound to a 3d sound
Function Add3Dsound(BaseSound As cSound, Optional MinDistance = DS3D_DEFAULTMINDISTANCE, Optional MaxDistance = DS3D_DEFAULTMAXDISTANCE, Optional ConeOutsideVolume As Long = DS3D_DEFAULTCONEOUTSIDEVOLUME) As Boolean
On Error GoTo LoadFailed
    ReDim Preserve Sound(0 To UBound(Sound) + 1)
    Set Sound(UBound(Sound)) = New c3Dsound
    With Sound(UBound(Sound))
        Set .BaseSound = BaseSound
        Add3Dsound = .Load(MinDistance, MaxDistance, ConeOutsideVolume)
    End With
    Exit Function
LoadFailed:
End Function



' get/set number of sound objects
Property Get NumSounds() As Long
On Error Resume Next
    NumSounds = UBound(Sound)
End Property
Property Let NumSounds(Num As Long)
On Error Resume Next
    ReDim Preserve Sound(0 To Num)
End Property



' cleans up audio
Function CleanUp()
Dim l As Long
On Error Resume Next
    ReDim Sound(0)
    Set Sound(0) = Nothing
    Set Listener = Nothing
End Function
